/*
 * vout.h
 * Copyright (C) 2010 - 2013 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __VOUT_H__
#define __VOUT_H__

#include <windows.h>

#ifndef __cplusplus
typedef struct IVideoOutput vout_t;
#else
extern "C" {
typedef class IVideoOutput vout_t;
#endif 

//#define VOUT_INIT
#if defined VOUT_INIT // {
void vout_init(HWND hWindow);
void vout_cleanup(HWND hWindow);
#endif // }

vout_t *vout_get(HWND hWindow);
void vout_open(vout_t *vo, int width, int height, double aspectratio);
void vout_close(vout_t *vo);

void vout_draw(vout_t *vo,
    unsigned char* yBaseAddr, long yRowBytes,
    unsigned char* vBaseAddr, long vRowBytes,
    unsigned char* uBaseAddr, long uRowBytes);
void vout_set_caption(vout_t *vo, char *buf);
HWND vout_get_hwnd(vout_t *vo);

#ifdef __cplusplus
}
#endif 

#endif // __VOUT_H__
